#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <stdlib.h>
#include <sys/time.h>

#define MAX_LINES   99
#define MAX_CHARS   4000
#define MAX_TXT     256
#define ITERATIONS  20
#define THRESHOLD   10.0
 

int debug = 0;

void help_msg(char *name) {
  (void) fprintf(stdout, "usage: %s  -d -c <# of times the Exercise has to repeated> -t <Thresold in micro seconds>-l <Logfile Name>  \n",name);
  (void) fprintf(stdout, "-d turn on the debugging \n");
  (void) fprintf(stdout, " threshold is a floating point number \n");
  
  return;
}


int run_popen(char **lineptr, char *buffer, char *exe_str)
 {
   int i, cnt=0;
   FILE *ptr, *popen();
   char *bufstart, *bufend, line[MAX_TXT], *fgets();

   bufstart = buffer;         
   bufend = buffer + MAX_CHARS;
   if((ptr =   popen(exe_str, "r")) == NULL)
       (void) fprintf(stderr,"Couldn't open pipe");

   for(i=0; i<MAX_LINES; i++)
       {
       if(fgets(line, MAX_TXT, ptr) == NULL)
          break;
       line[strlen(line)-1] = '\0'; 
       if((bufstart + strlen(line) + 1) >= bufend)
          (void) fprintf(stderr, "Line too long");
       lineptr[i]=bufstart;        
       strcpy(bufstart,line);      
       bufstart += strlen(line)+1; 
       cnt++;
       }

  fclose(ptr);
  return cnt;
 }


int getLoad()
{
 char *slines[MAX_LINES];
 char sbuf[MAX_CHARS];
 char *bcom_str = "./bprobe cs.uccs.edu";
 int count, i;

 count=run_popen(slines, sbuf, bcom_str);
 if (count < 1)
    return -1;

 for(i=0; i< count; i++)
	 printf (" line %d :: %s\n",i, slines[i]);

 return 1;
}

int main(int argc, char *argv[])
{
 
 if(getLoad() < 0)
        return -1;

}
