# Solaris 2.4/2.5 Makefile
# Thamer Al-Herbish shadows@whitefang.com

# Set your compiler here
CC = gcc

# Definitions specific to Solaris.
# You may need to uncomment this in Solaris 2.6
DEFINES = -DSOLARIS_CKSUM_BUG

# Tweak these if you have to

LIBS = -lsocket -lnsl
INCLUDE_DIR = -I.
CFLAGS = -Wall -g -c
LINK = $(CC) -o
COMPILE = $(CC) $(INCLUDE_DIR) $(DEFINES) $(CFLAGS) 
TARGETS = tcp udp ipicmp

# The rest should work.

all: $(TARGETS)

tcp: tcp.o in_cksum.o tcp_gen.o ip_gen.o trans_check.o
	$(LINK) tcp tcp.o in_cksum.o tcp_gen.o ip_gen.o trans_check.o $(LIBS)

udp: udp.o in_cksum.o udp_gen.o ip_gen.o trans_check.o
	$(LINK) udp udp.o in_cksum.o udp_gen.o ip_gen.o trans_check.o $(LIBS)

ipicmp: ipicmp.o in_cksum.o
	$(LINK) ipicmp ipicmp.o in_cksum.o $(LIBS)

.c.o:
	$(COMPILE) $<

clean:
	rm -rf *.o $(TARGETS)
