/*
** Ping.h
*/

#include "my_types.h"

#define MAX_PACKET_SIZE 1464

#define ICMP_ECHOREPLY	0
#define ICMP_ECHOREQ	8

/* IP Header -- RFC 791 */
typedef struct tagIPHDR
{
	t_u8  VIHL;			// Version and IHL
	t_u8	TOS;			// Type Of Service
	t_u16	TotLen;			// Total Length
	t_u16	ID;				// Identification
	t_u16	FlagOff;		// Flags and Fragment Offset
	t_u8	TTL;			// Time To Live
	t_u8	Protocol;		// Protocol
	t_u16	Checksum;		// Checksum
	struct	in_addr iaSrc;	// Internet Address - Source
	struct	in_addr iaDst;	// Internet Address - Destination
}IPHDR, *PIPHDR;


/* ICMP Header - RFC 792 */
typedef struct tagICMPHDR
{
	t_u8	Type;			// Type
	t_u8	Code;			// Code
	t_u16	Checksum;		// Checksum
	t_u16	ID;			// Identification
	t_u16	Seq;			// Sequence
	char	Data;			// Data
}ICMPHDR, *PICMPHDR;


/* ICMP Echo Request */
typedef struct tagECHOREQUEST
{
	ICMPHDR icmpHdr;
	struct timeval	dwTime;
	char	cData[MAX_PACKET_SIZE];
}ECHOREQUEST, *PECHOREQUEST;


/* ICMP Echo Reply */
typedef struct tagECHOREPLY
{
        IPHDR ipHdr;
	ECHOREQUEST	echoRequest;
	char    cFiller[256];
}ECHOREPLY, *PECHOREPLY;



