
#include <sys/sem.h>
#include <sys/shm.h>
#include "msock.h"


#define STICKY_ON_IP 		1
#define STICKY_ON_IP_PORT 	2
#define NON_STICKY		3


/*
** i need to remove this junk from chandra's code of xml parsing
*/
int 
   len_cr=2,
   len_lf=2,
   len_sp=1,
   len_la=1,
   len_ra=1,
   len_fs=1,
   len_ex=1,
   max_char_len=1;

char
   *c_cr="\r",
   *c_lf="\n",
   *c_sp=" ",
   *c_la="<",
   *c_ra=">",
   *c_fs="/",
   *c_ex="!";


struct ip_vs_cb_rule_field rule_fields[] =
{
{"purchase:1.totalAmount:1.", "" },
{"purchase:1.subTotal:1.", "" },
{"purchase:1.subTotal:2.", "" },
{"purchase:1.unitPrice:2.", "" }
};

static struct server server_list[] =
{
  {"eca.uccs.edu",         0x80c6c0bc},  /*128.198.192.198*/
  {"frodo.uccs.edu",       0x80c6c0b7},  /*128.198.192.183*/
  {"wallace.uccs.edu",     0x80c6c0d0},  /*128.198.192.183*/
  {"reject",               0xffffffff}
};


int num_rule_fields = sizeof(rule_fields) / sizeof(struct ip_vs_cb_rule_field);

int num_servers = sizeof(server_list) / sizeof(struct server);


#define STICKY_SIZE 			20			    /* allocation for maximum # of the sticky connection */

int *sticky_num;          		/* # of sticky entries in shared mem	*/
ip_sticky *sticky;


char *getRealServerName(u_long saddr)
{
 int i=0;

 for(i=0; i<num_servers; i++)
 {
  if(server_list[i].addr == saddr)
     return server_list[i].name ;
 }

 return NULL;  /* should not happen but for saftey */
}

/*
** temporary function for checking if the shared memory stuff is working properly or not
** should be removed soon gkgodava@archie.uccs.edu
*/
void printDetails(int semID,ip_sticky *s,int *sticky_num)
{
  int i=0;

  for(i=0;i<(*sticky_num);i++)
   (void) fprintf(stderr,"\a\a\t==>invoked pid %d source address %x destination address is %x\n",getpid(),s[i].source_ip, s[i].dest_ip);
  
  return ;
}

/*
** generates a random number to remove the information from shared memory 
** should be invoked in case of an overflow
*/
int removeSticky(void)
{
 srand(time(NULL));
 return (rand()%STICKY_SIZE);
}

/*
** adds a sticky connection information into the shared memory
*/
void addSticky(u_long saddr,u_long daddr)
{
 int loc;

   critical_lock_on();
 loc = (*sticky_num);
 if((*sticky_num) >= STICKY_SIZE)
   {
   loc = removeSticky();
/*
   printf("\t\t==>call to removeSticky noticed removing %d\n",loc);
*/
   }
 else
    (*sticky_num)++;

    sticky[loc].source_ip = saddr;
    sticky[loc].dest_ip = daddr;
   critical_lock_off();
return;
}

/*
** checks for the connection information i.e sticky or not, in the shared memory
** if found returns destination address else 0 
*/
u_long findSticky(u_long saddr)
{
  int i=0;
  u_long addr=0;

  critical_lock_on();
  for(i=0;i<(*sticky_num);i++) {
   if(saddr == sticky[i].source_ip) {
    critical_lock_off();
    return sticky[i].dest_ip;
   }

  }
   critical_lock_off();
  return 0 ;
}



void clear_rule_fld_values()
{
 int i = 0;
 for(i=0; i < num_rule_fields;i++)
   rule_fields[i].value[0] = '\0';

 return;
}

u_long route_to(char *server_name, int sticky_flag, u_long saddr)
{
 int i=0;
 u_long dest_addr = 0;

 for(i=0; i<num_servers; i++)
 {
  if(strcmp(server_name, server_list[i].name) == 0)
  {
    if(sticky_flag == STICKY_ON_IP)
    {
     addSticky(saddr,server_list[i].addr);
    }
    dest_addr = server_list[i].addr;
    break;
  }
 }
 return dest_addr;
}



u_long rule_configure(char *url, u_long saddr,u_long daddr, u_short sport, u_short dport, u_short protocol)
{

if (strstr(url,"zbwb_20") != NULL) {
  (void) fprintf(stderr,"pid %d url %s match found with rule 1\n",getpid(), url);
  return route_to("frodo.uccs.edu",NON_STICKY,saddr);
}

if (strstr(url,"zbwb_19") != NULL) {
  (void) fprintf(stderr,"pid %d url %s match found with rule 1\n",getpid(), url);
  return route_to("eca.uccs.edu",NON_STICKY,saddr);
}

if (strstr(url,"zbwb_18") != NULL) {
  (void) fprintf(stderr,"pid %d url %s match found with rule 1\n",getpid(), url);
  return route_to("frodo.uccs.edu",NON_STICKY,saddr);
}

if (strstr(url,"zbwb_17") != NULL) {
  (void) fprintf(stderr,"pid %d url %s match found with rule 1\n",getpid(), url);
  return route_to("eca.uccs.edu",NON_STICKY,saddr);
}

if (strstr(url,"zbwb_16") != NULL) {
  (void) fprintf(stderr,"pid %d url %s match found with rule 1\n",getpid(), url);
  return route_to("frodo.uccs.edu",NON_STICKY,saddr);
}

if (strstr(url,"zbwb_15") != NULL) {
  (void) fprintf(stderr,"pid %d url %s match found with rule 1\n",getpid(), url);
  return route_to("eca.uccs.edu",NON_STICKY,saddr);
}

if (strstr(url,"zbwb_14") != NULL) {
  (void) fprintf(stderr,"pid %d url %s match found with rule 1\n",getpid(), url);
  return route_to("frodo.uccs.edu",NON_STICKY,saddr);
}

if (strstr(url,"zbwb_13") != NULL) {
  (void) fprintf(stderr,"pid %d url %s match found with rule 1\n",getpid(), url);
  return route_to("eca.uccs.edu",NON_STICKY,saddr);
}

if (strstr(url,"zbwb_12") != NULL) {
  (void) fprintf(stderr,"pid %d url %s match found with rule 1\n",getpid(), url);
  return route_to("frodo.uccs.edu",NON_STICKY,saddr);
}

if (strstr(url,"zbwb_11") != NULL) {
  (void) fprintf(stderr,"pid %d url %s match found with rule 1\n",getpid(), url);
  return route_to("eca.uccs.edu",NON_STICKY,saddr);
}

if (strstr(url,"zbwb_10") != NULL) {
  (void) fprintf(stderr,"pid %d url %s match found with rule 1\n",getpid(), url);
  return route_to("frodo.uccs.edu",NON_STICKY,saddr);
}

if (strstr(url,"zbwb_9") != NULL) {
  (void) fprintf(stderr,"pid %d url %s match found with rule 1\n",getpid(), url);
  return route_to("eca.uccs.edu",NON_STICKY,saddr);
}

if (strstr(url,"zbwb_8") != NULL) {
  (void) fprintf(stderr,"pid %d url %s match found with rule 1\n",getpid(), url);
  return route_to("frodo.uccs.edu",NON_STICKY,saddr);
}

if (strstr(url,"zbwb_7") != NULL) {
  (void) fprintf(stderr,"pid %d url %s match found with rule 1\n",getpid(), url);
  return route_to("eca.uccs.edu",NON_STICKY,saddr);
}

if (strstr(url,"zbwb_6") != NULL) {
  (void) fprintf(stderr,"pid %d url %s match found with rule 1\n",getpid(), url);
  return route_to("frodo.uccs.edu",NON_STICKY,saddr);
}

if (strstr(url,"zbwb_5") != NULL) {
  (void) fprintf(stderr,"pid %d url %s match found with rule 1\n",getpid(), url);
  return route_to("eca.uccs.edu",NON_STICKY,saddr);
}

if (strstr(url,"zbwb_4") != NULL) {
  (void) fprintf(stderr,"pid %d url %s match found with rule 1\n",getpid(), url);
  return route_to("frodo.uccs.edu",NON_STICKY,saddr);
}

if (strstr(url,"zbwb_3") != NULL) {
  (void) fprintf(stderr,"pid %d url %s match found with rule 1\n",getpid(), url);
  return route_to("eca.uccs.edu",NON_STICKY,saddr);
}

if (strstr(url,"zbwb_2") != NULL) {
  (void) fprintf(stderr,"pid %d url %s match found with rule 1\n",getpid(), url);
  return route_to("frodo.uccs.edu",NON_STICKY,saddr);
}

if (strstr(url,"zbwb_1") != NULL) {
  (void) fprintf(stderr,"pid %d url %s match found with rule 1\n",getpid(), url);
  return route_to("eca.uccs.edu",NON_STICKY,saddr);
}

if (strstr(url,"ex") != NULL) {
  (void) fprintf(stderr,"pid %d url %s match found with rule 1\n",getpid(), url);
  return route_to("frodo.uccs.edu",NON_STICKY,saddr);
}

if (strstr(url,"htm") != NULL) {
  (void) fprintf(stderr,"pid %d url %s match found with rule 1\n",getpid(), url);
  return route_to("eca.uccs.edu",NON_STICKY,saddr);
}

if (strstr(url,"zdb") != NULL) {
  (void) fprintf(stderr,"pid %d url %s match found with rule 1\n",getpid(), url);
  return route_to("frodo.uccs.edu",NON_STICKY,saddr);
}

if (strstr(url,"gif") != NULL) {
  (void) fprintf(stderr,"pid %d url %s match found with rule 1\n",getpid(), url);
  return route_to("eca.uccs.edu",NON_STICKY,saddr);
}

if (strstr(url,"cs522") != NULL) {
  (void) fprintf(stderr,"pid %d url %s match found with rule 1\n",getpid(), url);
  return route_to("frodo.uccs.edu",NON_STICKY,saddr);
}
if (strstr(url,"cs301") != NULL) {
  (void) fprintf(stderr,"pid %d url %s match found with rule 2\n",getpid(), url);
  return route_to("eca.uccs.edu",NON_STICKY,saddr);
}

if (strstr(url,"cs") != NULL) {
  (void) fprintf(stderr,"pdi %d url %s match found with rule 3\n",getpid(), url);
  return route_to("frodo.uccs.edu",NON_STICKY,saddr);
}

if (strstr(url,"keepalive") != NULL) {
  (void) fprintf(stderr,"pid %d url %s match found with rule 5\n",getpid(), url);
  return route_to("eca.uccs.edu",NON_STICKY,saddr);
}

if (strstr(url,"gkgodava") != NULL) {
  (void) fprintf(stderr,"pid %d url %s match found with rule 4\n",getpid(), url);
  return route_to("frodo.uccs.edu",NON_STICKY,saddr);
}

if (strstr(url,"pre") != NULL) {
  return route_to("eca.uccs.edu",NON_STICKY,saddr);
}

if (saddr == 0x80c6c0ca){
  (void) fprintf(stderr,"pid  %d match found with rule 6\n",getpid(), saddr);
  return route_to("reject",NON_STICKY,saddr);
}

if (saddr == 0x80c63c17){
  (void) fprintf(stderr,"pid %d  %x match found with rule 7\n",getpid(), saddr);
  return (u_long)  route_to("eca.uccs.edu",NON_STICKY,saddr);
}

if (saddr == 0x80c6a2d9){
  (void) fprintf(stderr," pid %d match found with rule 8\n",getpid());
  return route_to("eca.uccs.edu",NON_STICKY,saddr);
}

if ((atoi(rule_fields[1].value) > 0) && (atoi(rule_fields[1].value) <50000)){
  (void) fprintf(stderr," pid %d xml parsing match found --1 with rule 9\n",getpid());
  return route_to("frodo.uccs.edu",NON_STICKY,saddr);
}

if (atoi(rule_fields[1].value) > 50000) {
  (void) fprintf(stderr,"pid %d  xml parsing match found --2 with rule 10\n",getpid());
  return route_to("eca.uccs.edu",NON_STICKY,saddr);
}

if (strstr(url,"lcs1") != NULL) {
  (void) fprintf(stderr,"pid %d url %s match found with rule11 \n",getpid());
  return route_to("frodo.uccs.edu",NON_STICKY,saddr);
}

if (strstr(url,"lcs2") != NULL) {
  (void) fprintf(stderr,"pid %d url %s match found with rule12 \n",getpid());
  return route_to("eca.uccs.edu",NON_STICKY,saddr);
}

(void) fprintf(stderr,"\n rule_fields[1].value = %d\n ", rule_fields[1].value);

  (void) fprintf(stderr,"default rule match found \n");
  return route_to("eca.uccs.edu",NON_STICKY,saddr);
}


char *mstrstr(char *source,  char *substr, size_t n)
{
  char *p = NULL;
  int  subStrLen = 0;

  p = strstr(source, substr);

  if(p == NULL)
  {
    subStrLen =  strlen(substr);
    if(!memcmp(source + n - subStrLen, substr, subStrLen))
      p = source + n - subStrLen;
  }
  return p;
}

int xml_tag_parser(char *buf)
{
  int   buf_len =strlen(buf);
  int   ret = 0;
  int   field_count = 0;
  short done_yet = 0;
  int   skip_len = 0;
  int   pos = 0;
  char  tag[64];
  char  pos_str[10];
  char  *p = NULL;
  char  *p1 = NULL;
  char  *fld_spec_beg = NULL;
  char  *fld_spec_end = NULL;
  char  *data_beg = NULL;
  char  *data_end = NULL;
  char  *tag_beg = NULL;
  char  *tag_end = NULL;


  for(field_count = 0; field_count < num_rule_fields; field_count++)
  { 
    fld_spec_beg = &(rule_fields[field_count].name[0]);
    fld_spec_end = &(rule_fields[field_count].name[strlen(rule_fields[field_count].name)]);
    data_beg = buf;
    data_end =(char *) (buf+buf_len);

    while(fld_spec_beg < fld_spec_end)
    {
      p = (char *)memchr(fld_spec_beg, ':', fld_spec_end - fld_spec_beg);

      if(!p)
      {
        (void) fprintf(stderr,"Invalid rule field specification '%s'\n", rule_fields[field_count].name);
        return -1;
      }

      memcpy(tag, fld_spec_beg, p - fld_spec_beg);
      tag[p - fld_spec_beg] = '\0';

      p += 1;
      p1 = (char *)memchr(p, '.', fld_spec_end - p);


      if(!p1)
      {
        (void) fprintf(stderr,"Invalid rule field specification '%s'\n", rule_fields[field_count].name);
        return -1;
      }

      memcpy(pos_str, p, p1 - p);

      pos_str[p1 - p] = '\0';
      fld_spec_beg = ++p1;

      pos = atoi(pos_str); 
    
      get_tag_range(tag, pos, data_beg, data_end, &tag_beg, &tag_end);
      if((!tag_beg) || (!tag_end))
      {
        (void) fprintf(stderr,"get_tag_range() returned NULL either for tag_beg or tag_end, "
               "tag_beg=%u, "
               "tag_end=%u, "
               "tag=%s, "
               "pos=%d ",
                ((tag_beg) ? (unsigned int) tag_beg : 0),
                ((tag_end) ? (unsigned int) tag_end : 0),
                tag,
                pos);

        return -1;
      }

      if(fld_spec_beg == fld_spec_end)
      {
        /* We have parsed all the sub fields of the field specified in the rule.
        ** Now parse data between tag_beg and tag_end and store in the field value
        ** after skipping white spaces, carriage returns and line feeds.
        */
        done_yet = 0;
        while((tag_beg < tag_end) && !done_yet)
        {
          done_yet = 1;
          skip_len = len_sp;
          if(!memcmp(tag_beg, c_sp, skip_len))
          {
            tag_beg += skip_len;
            done_yet = 0;
          }

          skip_len = len_cr;

          if(!memcmp(tag_beg, c_cr, skip_len))
          {
            tag_beg += skip_len;
            done_yet = 0;
          }

          skip_len = len_lf;
          if(!memcmp(tag_beg, c_lf, skip_len))
          {
            tag_beg += skip_len;
            done_yet = 0;
          }
        }

        done_yet = 0;

        while((tag_beg < tag_end) && !done_yet)
        {
          skip_len = len_sp;
          if(memcmp(tag_end - skip_len, c_sp, skip_len))
            skip_len = 0;

          if(!skip_len)
          {
            skip_len = len_cr;
            if(memcmp(tag_end - skip_len, c_cr, skip_len))
              skip_len = 0;
          }
         
          if(!skip_len)
          {
            skip_len = len_lf;
            if(memcmp(tag_end - skip_len, c_lf, skip_len))
              skip_len = 0;
          }
         
          if(skip_len)
            tag_end -= skip_len;
          else
            done_yet = 1;
        }

        if(tag_beg != tag_end)
        {
          if((tag_end - tag_beg) < sizeof(rule_fields[field_count].value))
          {
            memcpy(rule_fields[field_count].value, tag_beg, tag_end - tag_beg);
            rule_fields[field_count].value[tag_end - tag_beg] = '\0';
          }
          else
            (void) fprintf(stderr,"tag value size=%d is larger than its container size=%d for rule tag '%s' of field spec '%s'\n", (tag_end - tag_beg), sizeof(rule_fields[field_count].value), tag, rule_fields[field_count].name);
        }
        else
          (void) fprintf(stderr,"No value found for rule field spec '%s'\n", rule_fields[field_count].name);
      }
      else
      {
        data_beg = tag_beg;
        data_end = tag_end;
      }
    }
  } 
  return ret;
}



int get_tag_range(char *tag, int pos, char *hay_begin, char *hay_end, char **needle_begin, char **needle_end)
{
  char  temp_buf[67];
  int   curr_pos = 0;
  int   skip_len = 0;
  int   hay_len = 0;
  int   buf_len = 0;
  char  *p = NULL;
  char  *p_tmp = NULL;
  char  *p1 = NULL;
  char  *p_end = NULL;
  char  *p_beg = NULL;
  char  *tag_left = NULL;
  char  *tag_right = NULL;
  
  hay_len = hay_end - hay_begin;
  buf_len = hay_len;
  p = hay_begin;

  while(curr_pos < pos)
  {
    /*
    ** First Remove any leading comments
    */
    sprintf(temp_buf, "%s%s--", c_la, c_ex);


    if((p_tmp = mstrstr(p, temp_buf, hay_len)) != NULL)
    {
      /*
      ** Found the beginning of comment marker "<!--"
      ** Now find the end of comment marker "-->"
      */
       
	sprintf(temp_buf, "--%s", c_ra);


       if((p1 = mstrstr(p_tmp, temp_buf, buf_len - (p_tmp - hay_begin))) != NULL)
       {
         p = p1 + strlen(temp_buf);
         hay_len = buf_len - (p - hay_begin);
         continue;
       }
       else
       {
         (void) fprintf(stderr,"Bad xml data, no ending comment tag\n");
         break;
       }

    }

    sprintf(temp_buf, "%s%s", c_fs, tag);
    /*
    ** First look for end position "/tag" i.e., the vicinity of </tag> 
    */

    if((p_end = mstrstr(p, temp_buf, hay_len)) != NULL)
    {
      curr_pos++;
      if(curr_pos == pos)
      {
        /*
        ** Now look for begin position of the "tag" i.e., the vicinity of <tag>
        */

        if((p_beg = mstrstr(p, tag, hay_len)) != NULL)
        {
          /*
          ** First verify that it is a real tag 
          */

           tag_left = p_beg;
           tag_right = p_beg + strlen(tag);

          /*
          ** i.e, Below is a check for situations like <sometag> AtagB </sometag>
          */

           if(( (memcmp(tag_left - len_sp, c_sp, len_sp)) &&
                (memcmp(tag_left - len_ra, c_la, len_la)) &&
                (memcmp(tag_left - len_cr, c_cr, len_cr)) &&
                (memcmp(tag_left - len_lf, c_lf, len_lf)) ) || 
              ( (memcmp(tag_right, c_sp, len_sp)) &&
                (memcmp(tag_right, c_ra, len_ra)) &&
                (memcmp(tag_right, c_cr, len_cr)) &&
                (memcmp(tag_right, c_lf, len_lf)) ) )
           {
             p = tag_right;
             hay_len = buf_len - (p - hay_begin);
             --curr_pos;
             continue;
           }

           p_beg = tag_right;

           /*
           ** Find the position of '>' for p_beg
           */
           p = mstrstr(p_beg, c_ra, p_end - p_beg);

           if(p == NULL)
           {
             p_beg = NULL;
             p_end = NULL;
             break;
           }

           /*
           ** Find the position of '<' for beginning from p_beg
           */
           p_tmp = mstrstr(p_beg, c_la, p_end - p_beg);

           /*
           ** Below is a check for <sometag> tag </sometag>
           */

           if(p_tmp && (p_tmp < p))
           {
             hay_len = buf_len - (p - hay_begin);
             --curr_pos;
             continue;
           }

          /*
          ** Now eliminate all unwanted characters between p_beg and p_end
          ** such as white space, line feed, carriage return until until
          ** right and left anchors are seen respectively
          */

           if(p != NULL)
             p_beg = p + len_ra;
           else
           {
             /*
             ** We didn't find the  '>' for p_beg
             */
             p_beg = NULL;
             p_end = NULL;
             break;
           }

           /*
           ** Find the position of left anchor for p_end
           */

           while((p_end - max_char_len) > p_beg)
           {
             skip_len = len_la;
             if(!memcmp(p_end - skip_len, c_la, skip_len))
             {
               p_end -= skip_len;
               break;
             }

             skip_len = len_sp;
             if(!memcmp(p_end - skip_len, c_sp, skip_len))
               p_end -= skip_len;


             skip_len = len_cr;
             if(!memcmp(p_end - skip_len, c_cr, skip_len))
               p_end -= skip_len;

             skip_len = len_lf;
             if(!memcmp(p_end - skip_len, c_lf, skip_len))
               p_end -= skip_len;
           }
        }
      }
      else
      {
        /*
        ** Advance p for the next <tag>...data...</tag> block
        */
        p = p_end + strlen(temp_buf);
        hay_len = buf_len - (p - hay_begin);
      }
    }
    else
    /*
    ** No specified needle found in the hay
    */
      break;

  }

  *needle_begin = p_beg;
  *needle_end = p_end;
  
 return 0;

}

/*
** borrwed from thttpd
*/

static int hexDigit(char c)
{
    if (strchr("0123456789abcdefABCDEF",c) != (char *) NULL)
        return (1);

    return (0);
}

/*
** from thttpd source code
*/
static int hexIt(char c)
{
    if ((c >= '0') && (c <= '9'))
        return (c-'0');

    if ((c >= 'a') && (c <= 'f'))
        return (c-'a'+10);

    if ((c >= 'A') && (c <= 'F'))
        return (c-'A'+10);

    return (0);           /* shouldn't happen, but for saftey  */

}



/*
** from thttpd source code
*/
static char *strDecode(char *from)
{
char *to;
char *start=NULL;

    if (from  == (char *) NULL)
        return ((char *) NULL);


    to = (char *) malloc ((int) strlen(from) + 1);

    if (to == (char *) NULL)
    {
        perror("memory allocation problem strDecode()");
        exit(0);
    }

    start = to;

    for (; *from != '\0'; ++to,++from)
    {
        if (*from == '%' && hexDigit(from[1]) &&
            hexDigit(from[2]))
        {
            *to=hexIt(from[1])*16+hexIt(from[2]);
            from += 2;
        }
        else
            *to = (*from=='+') ?' ': *from;      /* inorder to replace + in post request with a space */
    }
    *to='\0';

return start;
}


u_long ruleMatching(Rule *rule)
{
  u_long ret_addr = 0;
  int ret=0,i=0;

  if((ret_addr = findSticky(rule->clientaddr)) > 0)
     return ret_addr;


  if(strncasecmp(rule->method, "POST", 4) == 0)
  {
    if(strstr(rule->content_type,"x-www-form-urlencoded") != NULL)
       (void) fprintf(stderr, " encoded body when decoded =>%d\n",(ret=xml_tag_parser(strDecode(rule->body))));

    for(i=0;i < num_rule_fields;i++)
     (void) fprintf(stderr, "rule %s value %s\n ", rule_fields[i].name, rule_fields[i].value);
  }

  if(ret >= 0)
  {
     ret_addr = (u_long)  rule_configure(rule->url,rule->clientaddr, (u_long) SERVER_IP, (u_short) rule->port, (u_short) SERVER_PORT,12);
     clear_rule_fld_values();
  }

  return ret_addr;

}


